<?php
/**
 *
 */
class Newslog_Tools_Feed {

    const TYPE_ALL      = 'all';

    const TYPE_FULL     = 'full';

    const TYPE_COMPLETE = 'complete';

    /**
     * @var Newslog_Tools_Feed
     */
    private static $_instance = null;

    private $_news      = array();

    private $_feedTpye  = self::TYPE_FULL;

    private function __construct() {}

    private function __clone() {}

    public static function getInstance() {
        if(self::$_instance === null) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }



    public function generate(array $news, $feedType = self::TYPE_COMPLETE) {
        if(empty($news)) {
            Tools_System_Tools::debugMode() || error_log('Cant generate xml feed. No news found.');
            return false;
        }
        switch($feedType) {
            case self::TYPE_COMPLETE:

                $this->_generate($news, self::TYPE_FULL);
                $this->_generate($news, self::TYPE_ALL);

                // generate rss feed per news tag
                $newsByTags = array();
                foreach($news as $newsItem) {
                   $tags = $newsItem->getTags();
                    if(empty($tags)) {
                        continue;
                    }
                    foreach($tags as $tag) {
                        $newsByTags[$tag['name']][] = $newsItem;
                    }
                }

                if(!empty($newsByTags)) {
                    foreach($newsByTags as $tag => $news) {
                        $this->_generate($news, $tag);
                    }
                }

            break;
            case self::TYPE_FULL:
            case self::TYPE_ALL:
                $this->_generate($news, $feedType);
            break;
            default:
                Tools_System_Tools::debugMode() || error_log('Cant generate xml feed. Invalid feed type');
                return false;
            break;
        }
    }

    private function _generate($news, $feedName) {

        $websiteHelper = Zend_Controller_Action_HelperBroker::getStaticHelper('website');
        $miscConfig    = Zend_Registry::get('misc');
        $view          = new Zend_View(array(
            'scriptPath' => $websiteHelper->getPath() . $miscConfig['pluginsPath'] . 'newslog/system/views/'
        ));

        $view->news          = $news;
        $view->feedType      = $feedName;
        $view->websiteUrl    = $websiteHelper->getUrl();
        $view->websitePath   = $websiteHelper->getPath();
        $view->newsConfig    = Newslog_Models_Mapper_ConfigurationMapper::getInstance()->fetchConfigParams();
        $view->websiteConfig = Application_Model_Mappers_ConfigMapper::getInstance()->getConfig();

        try {
            Tools_Filesystem_Tools::saveFile($websiteHelper->getPath() . $miscConfig['feedsPath'] . $feedName . '.xml', $view->render('feed.phtml'));
        } catch (Exception $e) {
            error_log($e->getMessage());
            return false;
        }
        return true;
    }

}
